//this file is part of eMule
// added by itsonlyme
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// itsonlyme: viewSharedFiles

#pragma once
#include "Resource.h"
#include "ResizableLib/ResizablePage.h"
#include "TreeOptionsCtrlEx.h"
#include "SearchList.h"

#define		MP_SFP_REFRESH_ROOT		1
#define		MP_SFP_REFRESH_DIR		2
#define		MP_SFP_DOWNLOAD			3

#define		BLCT_UNKNOWN	0
#define		BLCT_ROOT	1
#define		BLCT_FILE	2
#define		BLCT_DIR	3
#define		BLCT_LOCALFILE	4

struct BLCItem_struct {
	BLCItem_struct ();
	~BLCItem_struct ();
	int				m_iItemType;
	CString			m_fullPath;
	CString			m_name;
	CSearchFile*	m_file;
	CKnownFile*		m_knownFile;
};

//////////////////////////////////////////////////////////////////////////////
// CSharedFilesPage dialog

class CSharedFilesPage : public CResizablePage
{
	DECLARE_DYNAMIC(CSharedFilesPage)

public:
	CSharedFilesPage();   // standard constructor
	virtual ~CSharedFilesPage ();

	void	UpdateTree(CString newDir);
	void	SetMyclient(CUpDownClient* client)	{m_client = client;}
	void	SetLocalFiles()	{m_bLocalFiles = true;}

// Dialog Data
	enum { IDD = IDD_PPG_TWEAKS };

protected:
	void	FillTree();
	void	GetDirs();
	int		GetFileIcon(CString filename);
	void	SortDirs(HTREEITEM hParent);
	bool	FilterDirs(CRBMap<CString, bool> *listDirs, HTREEITEM hParent);
	void	Localize();
	HTREEITEM	GetItemUnderMouse();
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT *pResult);
	virtual BOOL OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	afx_msg void OnDestroy();
	afx_msg void OnExtOptsDblClick(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnItemExpanding (NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnExtOptsRightClick(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);//[TPT] - New Menu Style

	DECLARE_MESSAGE_MAP()

private:
	int m_iImgRoot;
	int m_iImgShDir;
	int m_iImgDir;
	bool m_bInitDone;
	bool m_bLocalFiles;
	CString m_strCaption;
	CString m_strToolTip;

	CUpDownClient* m_client;
	CTreeOptionsCtrlEx m_ctrlTree;
	CToolTipCtrl *m_toolTip;

	CTypedPtrList<CPtrList, BLCItem_struct*> m_BLCItem_list;
	CRBMap<CString, HTREEITEM> m_HTIs_map;
	CRBMap<CString, bool> m_dirsList;

	CMap<int, int, int, int> m_iconMap;

	HTREEITEM m_htiRoot;
	HTREEITEM m_htiOldToolTipItemDown;
};

